import react from 'react';
import { IonButton, IonIcon } from '@ionic/react';
import { arrowBackCircleOutline } from 'ionicons/icons';
import './BackForward.css';

export interface BackProperties {}

export const Back: react.FC<BackProperties> = (props: BackProperties) => {
  const onClickHandler = (event: any) => {
    window.history.back();
  };

  return (
    <IonButton
      onClick={onClickHandler}
      size='large'
      className='back-forward'
      shape='round'
      fill='solid'
    >
      <IonIcon slot='icon-only' icon={arrowBackCircleOutline} />
    </IonButton>
  );
};

export default Back;
