import react, { startTransition, useEffect, useState } from 'react';
import dispatch from '../../workers/dispatcher-main';
import { TileKeyObject, Rectangle } from './types';
import getUri from '../../lib/ids';
import Trkseg from './Trkseg';

export interface TrkProperties {
  id: string;
  keyObject: TileKeyObject;
  zoom: number;
  viewPort: Rectangle;
}

export const Trk: react.FC<TrkProperties> = (props: TrkProperties) => {
  const [trk, setTrk] = useState<any>([]);
  useEffect(() => {
    const getTrk = async () => {
      const trk = await dispatch({
        action: 'getTrk',
        params: {
          id: props.id,
        },
      });
      console.log(`<Trk>, gpx: ${JSON.stringify(trk)}`);
      startTransition(() => setTrk(trk));
    };
    getTrk();
  }, [props.id]);

  return (
    <g>
      {trk
        .filter((row: any) => row.doc.type === 'trkseg')
        .map((row: any) => (
          <Trkseg
            key={row.id}
            id={row.id}
            keyObject={props.keyObject}
            zoom={props.zoom}
            viewPort={props.viewPort}
          />
        ))}
    </g>
  );
};

export default Trk;
