import { initDb } from '../db';
import {
  putNewGpx,
  existsGpx,
  pruneAndSaveImportedGpx,
  getGpxesForViewport,
  getGpx,
} from '../db/gpx';
import { getTrk, putNewTrk } from '../db/trk';
import { getTrkseg } from '../db/trkseg';

const self = globalThis as unknown as WorkerGlobalScope;

const actions = {
  initDb,
  putNewGpx,
  putNewTrk,
  existsGpx,
  pruneAndSaveImportedGpx,
  getGpxesForViewport,
  getGpx,
  getTrk,
  getTrkseg,
};

onmessage = async function (e) {
  console.log(`Worker received ${JSON.stringify(e.data)}`);
  const { id, payload } = e.data;
  console.log(`payload.action in actions: ${payload.action in actions}`);
  var returnValue: any = 'unknownAction';
  if (payload.action in actions) {
    returnValue = await actions[<keyof typeof actions>payload.action](
      payload.params
    );
  }
  postMessage({ id: id, payload: returnValue });
};

export default self;
